package com.biganto.visual.roompark.presentation.screen.home

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.viewpager.widget.ViewPager
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.IBottomNavigation
import com.biganto.visual.roompark.base.ICollapsingToolBar
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.biganto.visual.roompark.presentation.screen.auth.AuthScreenController
import com.biganto.visual.roompark.presentation.screen.splash.SplashScreenController
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 11.10.2019.
 */

class HomeController :
    BigantoBaseController<HomeScreenViewState
            , HomeScreen
            , HomeScreenPresenter>()
    , HomeScreen {

    override fun injectDependencies() {
        getComponent()
    }

    @BindView(R.id.home_router_host)
    lateinit var viewpager: ViewPager

    @Inject
    lateinit var tb: ICollapsingToolBar

    @Inject
    lateinit var bottomNavigation: IBottomNavigation

    @Inject
    override lateinit var injectedPresenter: HomeScreenPresenter

    lateinit var pageAdapter : BNVRouterPagerAdapter



//    @Inject
//    lateinit var snacky:ISnackBarProvider


    fun getComponent() = DaggerHomeScreenComponent
        .factory()
        .create(RoomParkApplication.component,activity as RoomParkMainActivity)
        .inject(this)

//    @Inject
//    lateinit var ac: RoomParkMainActivity

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup): View {
        val v = super.onCreateView(inflater, container)

        tb.showAll()
        pageAdapter = BNVRouterPagerAdapter(this,bottomNavigation.bottomNavigation,viewpager,
            mapOf(
                Pair(R.id.tab_feeds,{SplashScreenController()})
                ,Pair(R.id.tab_favorites,{AuthScreenController()})
                ,Pair(R.id.tab_deals,{AuthScreenController()})
                ,Pair(R.id.tab_look_flat,{AuthScreenController()})
                ,Pair(R.id.tab_settings,{SplashScreenController()})
            )
        )
        return v
    }


    override fun render(viewState: HomeScreenViewState) {
        when(viewState){
            is HomeScreenViewState.Idle -> render(viewState)
            is HomeScreenViewState.ToScreen -> render(viewState)
        }
    }

    private fun render(viewState: HomeScreenViewState.Idle){

    }

    private fun render(viewState: HomeScreenViewState.ToScreen){


//        snacky.showSnackBar("lul")
    }


    override fun getLayoutId(): Int = R.layout.home_screen_viewpager


}